/*
------------------------------------
	Copy Colour Functions v1.5
------------------------------------
	Created by Matt Stow 2011
	http://www.mattstow.com
------------------------------------
*/

function GetCopyPreferences() {
	var hex = "true";
	var lowercase = "true";
	var shorthand = "true";
	var incHash = "true";
	var fileName = fw.appPrefsDir + "/Copy Colour Preferences.txt";
	var prefsArray = new Array();
	if (Files.exists(fileName) == true) {
		var fileRef = Files.open(fileName, false);
		prefsArray.push(fileRef.readline());
		prefsArray.push(fileRef.readline());
		prefsArray.push(fileRef.readline());
		prefsArray.push(fileRef.readline());
		fileRef.close();
	}
	if ((prefsArray[0] != "true") && (prefsArray[0] != "false")) {
		prefsArray[0] = hex;
	}	
	if ((prefsArray[1] != "true") && (prefsArray[1] != "false")) {
		prefsArray[1] = lowercase;
	}
	if ((prefsArray[2] != "true") && (prefsArray[2] != "false")) {
		prefsArray[2] = shorthand;
	}
	if ((prefsArray[3] != "true") && (prefsArray[3] != "false")) {
		prefsArray[3] = incHash;
	}
	return prefsArray;
}

function CopyToClipboard(colour, hex, lowercase, shorthand, incHash, opacity) {
	var originalSelection = [].concat(fw.selection);
	colour = colour.replace("#", "");
	if (hex == "true") {
		if (lowercase == "true") {
			colour = colour.toLowerCase();
		}
		else {
			colour = colour.toUpperCase();
		}
		if (colour.length > 6) {
			colour = colour.slice(0,6);
		}
		if (shorthand == "true") {
			if ((colour.charAt(0) == colour.charAt(1)) && (colour.charAt(2) == colour.charAt(3)) && (colour.charAt(4) == colour.charAt(5))) {
				var colourTemp = colour.charAt(0);
				colourTemp += colour.charAt(2);
				colourTemp += colour.charAt(4);
				colour = colourTemp;
			}
		}
		if (incHash == "true") {
			colour = "#" + colour;
		}
	}
	else {
		var r = parseInt(colour.substring(0, 2), 16);
		var g = parseInt(colour.substring(2, 4), 16);
		var b = parseInt(colour.substring(4, 6), 16);
		if (opacity) {
			var aOpacity = Round(opacity);
			if (aOpacity == 1)
				colour = "rgb(" + r + "," + g + "," + b + ")";
			else
				colour = "rgba(" + r + "," + g + "," + b + "," + aOpacity + ")";
		}
		else {
			if (colour.length > 6) {
				var a = parseInt(colour.substring(6, 8), 16);
				a = a/2.55;
				a = Round(a);
				colour = "rgba(" + r + "," + g + "," + b + "," + a + ")";
			}
			else {
				colour = "rgb(" + r + "," + g + "," + b + ")";
			}
		}
	}
	var dom = fw.getDocumentDOM();
	dom.addNewText({left:-100, top:-100, right:-100, bottom:-100}, true);
	var tr = fw.selection[0].textRuns;
	tr.textRuns = [{changedAttrs: {}, characters:colour}];
	fw.selection[0].textRuns = tr;
	dom.clipCopyFormats("(ADOBE AI3)");
	dom.deleteSelection(false);
	fw.selection = originalSelection;
}

function Round(num) {
	var number = (Math.round(num*Math.pow(10,2)) / Math.pow(10,2) / 100);
	number = Math.round(number*Math.pow(10,2)) / Math.pow(10,2);
	return number;
}